﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Public Sub Process_Globals
End Sub

'Adds a leading forward slash if not already present
'Address - url text
'
'Example: <code>
'Format.CheckLeadingSlash("upnp/event/cds")</code>
'Returns "/upnp/event/cds"
Public Sub CheckLeadingSlash( Address As String) As String
	If Address.StartsWith("/") Then
		Return Address
	Else
		Return "/" & Address
	End If
End Sub

'Scales image to a new width and height
'Original - image file
'Width - required width
'Height - required height
'Filter - antialiasing filter
'
'Example: <code>
'server.iconBitmap = Format.CreateScaledBitmap(Job.GetBitmap, 80dip, 80dip, True)</code>
'Returns a scaled image 80dipx80dip
Public Sub CreateScaledBitmap(Original As Bitmap, Width As Int, Height As Int, Filter As Boolean) As Bitmap
   Dim r As Reflector
   Dim b As Bitmap
   Width = Width/2
   Height = Height/2
   b = r.RunStaticMethod("android.graphics.Bitmap", "createScaledBitmap", _
      Array As Object(Original, Width, Height, Filter), _
      Array As String("android.graphics.Bitmap", "java.lang.int", "java.lang.int", "java.lang.boolean"))
   Return b
End Sub

'Format string to replace reserved HTML characters with corresponding entities
'Raw - string requiring formatting
'
'Example: <code>
'newString = Format.EntitiesHTML("<'unformatted string'>") </code>
'Returns a new string with &lt;, &apos; and &gt; replaced with HTLM entities
Public Sub EntitiesHTML(Raw As String) As String
  Dim sb As StringBuilder
  sb.Initialize
  Dim i As Int
  For i = 0 To Raw.Length - 1
    Dim c As Char = Raw.CharAt(i)
    Select c
      Case QUOTE
        sb.Append("&quot;")
      Case "'"
        sb.Append("&apos;")
      Case "<"
        sb.Append("&lt;")
      Case ">"
        sb.Append("&gt;")
      Case "&"
        sb.Append("&amp;")
      Case Else
        sb.Append(c)
    End Select
  Next
  Return sb.ToString
End Sub

'Determine current screen orientation
'
'Example: <code>
'Orientation = Format.GetScreenOrientation </code>
'Returns 0=Portrait, 1=Landscape ,2=Reverse Portrait ,3=Reverse Landscape
Public Sub GetScreenOrientation As String
	'0=Portrait, 1=Landscape ,2=Reverse Portrait ,3=Reverse Landscape
   Dim r As Reflector
   r.Target = r.GetContext
   r.Target = r.RunMethod2("getSystemService", "window", "java.lang.String")
   r.Target = r.RunMethod("getDefaultDisplay")
   Select r.RunMethod("getOrientation")
   	Case 0,2
		Return "portrait"
	Case Else
		Return "landscape"
	End Select
End Sub