﻿Type=Service
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Dim imgBitmap As Bitmap ' Bitmap used to show the selected picture
End Sub

Sub Service_Create
End Sub

Sub Service_Start (StartingIntent As Intent)
End Sub

Sub Service_Destroy
End Sub

Public Sub Load(key As String)
	' Retreive the container with key selected
	Dim container As itemContainer
	container.Initialize
	container =	UPNP.browseResults.Get(key)
	' Get the path for the selected image
	Dim imgPath As String
	imgPath = container.location
	Debug.debugLog("##### SELECTED IMAGE FILE DETAILS  #####" & CRLF & _
				   "      [id         =" & key & "] " & CRLF & _
				   "      [title      =" & container.title & "] " & CRLF & _
				   "      [class      =" & container.itemClass & "]" & CRLF & _
				   "      [resolution =" & container.strResolution & "]" & CRLF & _
				   "      [location   =" & container.location & "]") 'DEBUG
	' Check that imgPath contains and download the selected image
	If imgPath <> "" Then
		Dim httpReq As HttpJob
		httpReq.Initialize("image", Me)
		httpReq.Download(imgPath)
	End If
End Sub

Private Sub JobDone (job As HttpJob)
	' Event raised when httpReq download completed or failed
	Debug.debugLog("JobName = " & job.JobName & ", Success = " & job.Success) 'DEBUG
	If job.Success = True Then
		' Store image and call Image_View activity
		imgBitmap.Initialize3(job.GetBitmap)
		StartActivity(Image_View)
	Else
		' Download request failed, notify user
		Debug.debugLog("Error: " & job.ErrorMessage) 'DEBUG
		If job.ErrorMessage = "Internal Server Error" Then
			CallSubDelayed3(Main, "ShowMsgBox", "Please check network and sharing setting on the remote device.", "Access Denied!")
		End If
	End If
	job.Release
End Sub