﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
' Original code provided by Erel Uziel and can be found here...
' http://www.b4x.com/android/forum/threads/scrolling-labels.8831/#post-49199

Sub Process_Globals
	Type ScrollingLabel (lbl As Label, Canvas As Canvas, Bitmap As Bitmap, _ 
		SrcRect As Rect, DestRect As Rect, InhibitScroll As Boolean, Pause As Boolean)
	Dim Gap As Int = 10dip
End Sub

Sub StartScrolling (lbl As Label, txt As String, chk As Boolean) As ScrollingLabel
	' Declare and initialise custom type ScrollingLabel
	Dim SL As ScrollingLabel
	SL.Initialize
	' Add label and create a canvas for drawing on it
	SL.lbl = lbl
	SL.Canvas.Initialize(lbl)
	' Get text dimensions
	Dim txtWidth, txtHeight As Int
	txtWidth = SL.Canvas.MeasureStringWidth(txt, lbl.Typeface, lbl.TextSize)
	txtHeight = SL.Canvas.MeasureStringHeight(txt, lbl.Typeface, lbl.TextSize)
	' Test whether or not scrolling is required i.e. text is wider than label width
	If chk = True Then
		If txtWidth < lbl.Width Then
			SL.InhibitScroll=True
		Else
			SL.InhibitScroll=False
		End If
	End If
	' Create and initialise mutable bitmap and a canvas
	Dim b As Bitmap
	b.InitializeMutable(txtWidth + lbl.Width + Gap, lbl.height)
	Dim c As Canvas
	c.Initialize2(b)
	' Load the text onto the canvas and initialise source and destination rectangles
	c.DrawText(txt, 0dip, b.height/2 + txtHeight/2, lbl.Typeface, lbl.TextSize, lbl.TextColor, "LEFT")
	SL.SrcRect.Initialize(0, 0, lbl.width, lbl.height)
	SL.DestRect.Initialize(0, 0, lbl.width, lbl.height)
	SL.Bitmap = b
	SL.Canvas.DrawBitmap(SL.Bitmap, SL.SrcRect, SL.DestRect)
	' Force label to redraw itself and return ScrollingLabel
	SL.lbl.Invalidate
	Return SL
End Sub

Sub TimerTick (Labels As List)
	Dim repeatDelay As Boolean = True
	' Loop through all ScrollingLabels
	For i = 0 To Labels.Size - 1
		' Get ScrollingLabel from list
		Dim SL As ScrollingLabel
		SL = Labels.Get(i)
		' Check if stopped or paused from scrolling
		If SL.InhibitScroll = False AND SL.Pause=False Then
			' Update source rectangle left and right
			SL.SrcRect.Left = SL.SrcRect.Left + 1dip
			SL.SrcRect.Right = SL.SrcRect.Left + SL.lbl.Width
			If SL.SrcRect.Right > SL.Bitmap.Width Then
				' Reset scrolling label, one full rotation complete
				SL.SrcRect.Left = 0
				SL.SrcRect.Right = SL.SrcRect.Left + SL.lbl.Width
				SL.Pause=True
			Else
				' Continue scrolling
				If SL.InhibitScroll = False Then repeatDelay = False
			End If
			' Update scrolling label
			SL.Canvas.DrawRect(SL.DestRect, Colors.Transparent, True, 0)
			SL.Canvas.DrawBitmap(SL.Bitmap, SL.SrcRect, SL.DestRect)
			SL.lbl.Invalidate
		End If
	Next
	' Only triggered if all scrolling labels have completed one full rotation, pause before re-scroll
	If repeatDelay = True Then CallSubDelayed(Main, "ScrollTimer_Pause")
End Sub