﻿Type=Activity
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
End Sub

Sub Globals
	Dim vv As VideoView ' Native VideView (Very limited CODEC support!)
End Sub

Sub Activity_Create(FirstTime As Boolean)
	' Activity started if Vplayer or MxPlayer not installed, attempt to use native VideoView
	' Set screen orientation to landscape
	Dim p As Phone
	p.SetScreenOrientation(0)
	' Create panel to contain VideoView
	Dim vvPanel As Panel
	vvPanel.Initialize("vvPanel")
	Activity.AddView(vvPanel, 0dip, 0dip, 100%x, 100%y)
	' Attempt to center VideoView if aspect ratio info is available
	Dim ratio As Float
	Dim vvPanelOffset As Int
	If Video.vidResolution.X = 0 AND Video.vidResolution.Y = 0 Then
		' Default position, no aspect ratio info available
		ratio = 1
		vvPanelOffset = 0dip
	Else
		' Centered position using aspect ratio info
		ratio = Video.vidResolution.X / Video.vidResolution.Y
		vvPanelOffset = (vvPanel.Height - (vvPanel.Width / ratio))/2
	End If
	' Set background color and create VideoView within panel
	vvPanel.Color=Colors.Black
    vv.Initialize("vv")
    vvPanel.AddView(vv, 0dip, vvPanelOffset, 100%x , vvPanel.Width / ratio)
	' Notify user that VideoView has limited CODEC support
	issueVideoViewWarning
	' Load and play the video
    vv.LoadVideo("http", Video.vvPath)
    vv.Play
End Sub

Sub Activity_Resume
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	' Release the screen orientation setting
	If UserClosed = True Then
		Dim P As Phone
		P.SetScreenOrientation(-1)
		' Resume browsing if more results available
		If UPNP.browseIDResume <> "" Then
			CallSub2(Main, "progress_Update", True)
			CallSub3(UPNP, "BrowseServer", UPNP.browseIDResume, UPNP.browseMetaDataResume)
		End If
	End If
End Sub

Private Sub issueVideoViewWarning
	' Notify user that VideoView has limited CODEC support
	Msgbox("The standard Android player has very limited CODEC support." & CRLF & _
			"It is recommended to install a third party player from the Play Store such as MxPlayer or VPlayer." & CRLF & CRLF & _
			"The file will now attempt to be played!" , "Warning")
End Sub